/*
 * ணࠬ ஢ 奬. (C) 1999,  祭 (if@hypersoft.ru)
 *
 * ணࠬ  奬, ⥬    室 ᪨
 * ஢  ࠢ 室 ᨣ 奬  ⠫묨.
 * ⠫ ᨣ ,  ᪠ 㭪  室
 * ᨣ  ⨯ 奬.  奬   㬥
 * ணࠬ.
 * ᪠  ᫥ ⨯ 奬:
 *  00 - ஢塞 奬  ⮬ 4  2-  TTL-室
 *       (7400,1553,74S00,74LS00,74ALS00,74F00)
 *  08 - ஢塞 奬  ⮬ 4  2  TTL-室
 *       (7408,1551,...)
 *  32 - ஢塞 奬  ⮬ 4  2  TTL-室
 *       (7432,1551,...)
 *  86 - ஢塞 奬  ⮬ 4  2XOR  TTL-室
 *       (7486,1555,...)
 *
 * ணࠬ ᯮ ࠫ  LPT1.
 */

#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

typedef unsigned char BYTE;
typedef int BOOL;

#define VERSION     "V1.0"
#define COPYRIGHT   "(C) 1999,  祭 (if@hypersoft.ru)"
#define MAXINPUTS   8
#define MAXOUTPUTS  8

#define DATA_PORT   0x378
#define STATUS_PORT 0x379

//। ࠧ冷  ﭨ.

#define ERROR_BIT 0x08
#define SLCT_BIT  0x10
#define PE_BIT    0x20
#define ACK_BIT   0x40
#define BUSY_BIT  0x80

#define CONTROL_PORT 0x037A

//। ࠧ冷  ࠢ.

#define STROBE_BIT 0x01
#define AUTOFEED_BIT 0x02
#define INIT_BIT   0x04
#define SLCTIN_BIT 0x08
#define INTENABLED_BIT 0x10
#define DATAIN_BIT 0x20

/* ⥪饥 ᮤন  ࠢ. */
static BYTE control_port_value = 0;

/* 뢮    ࠫ .  STROBE 饫
      ॣ ⮢ . */
void output_data (BYTE data)
{
  outportb(DATA_PORT, data);
  control_port_value |= STROBE_BIT;
  outportb(CONTROL_PORT, control_port_value);
#ifdef DELAY_IT
  delay (1);
#endif
  control_port_value &= ~STROBE_BIT;
  outportb(CONTROL_PORT, control_port_value);
#ifdef DELAY_IT
  delay (1);
#endif
}

/* ⥭  ﭨ ࠫ쭮  */
BYTE read_status(void)
{
#ifdef DELAY_IT
  delay(1);
#endif
  return inportb(STATUS_PORT);
}
/* ⥭    ࠫ쭮    ﭨ */
BYTE read_fake_data (void)
{
  BYTE result,
       result1;

  control_port_value &= ~INIT_BIT;  /* ⨯  ० ।
                                       襩 ࠤ */
  outportb(CONTROL_PORT, control_port_value);
  result = (inportb(STATUS_PORT) & 0xF0) >> 4;
  control_port_value |= INIT_BIT;  /* ⨯  ० ।
				       襩 ࠤ */
  outportb(CONTROL_PORT, control_port_value);
  result1 = (inportb(STATUS_PORT) & 0xF0);
  result |= result1;
  result ^= 0x33;
  return result;
}

/* ⥭    ࠫ쭮 , ᫨  㭠ࠢ.
    饩 ᨨ   ᯮ. */
BYTE read_data (void)
{
#ifdef DELAY_IT
  delay(1);
#endif
  return inportb(DATA_PORT);
}


typedef BOOL (*logic2X1) (BOOL i1, BOOL i2);

/* ᫥ ⠫ ᨣ  2- */
BOOL lf2NAND (BOOL i1, BOOL i2)
{
  return !(i1 & i2);
}

/* ᫥ ⠫ ᨣ  2 */
BOOL lf2OR (BOOL i1, BOOL i2)
{
  return (i1 | i2) != 0;
}

/* ᫥ ⠫ ᨣ  2 */
BOOL lf2AND (BOOL i1, BOOL i2)
{
  return (i1 & i2) != 0;
}

/* ᫥ ⠫ ᨣ  2XOR */
BOOL lf2XOR (BOOL i1, BOOL i2)
{
  return (i1 ^ i2) != 0;
}

void ByteToBits (BYTE val, BOOL* result)
{
  int i;

  for ( i = 0; i < 8; i++ )
    *result++ = (val & (1 << i)) != 0;
}

void usage (void)
{
  printf ("ᯮ짮:\n");
  printf ("uctest ⨯_奬 [᫮ ७ ]\n");
  printf ("    ⨯_奬  :\n");
  printf ("       00 - ஢ 奬 42- (7400,1553)\n");
  printf ("       08 - ஢ 奬 42    (7408,1551)\n");
  printf ("       32 - ஢ 奬 42  (7432,1551)\n");
  printf ("       86 - ஢ 奬 42XOR  (7486,1555)\n");
}

void main (int argc, char** argv)
{
  int uc_type,
      i, j, rc, error,
      test;
  long passes = 1;
  logic2X1 testp = NULL;
  char reply[30];
  BOOL inputs[MAXINPUTS],
       outputs[MAXOUTPUTS];
  char* ucname;

  printf ("஢ 奬 %s   %s\n", VERSION, COPYRIGHT);
  if (argc >= 2) {
    uc_type = atoi(argv[1]);
    if (argc >= 3)
      passes = atol(argv[2]);
    if (passes == 0)
      passes = 1;
  } else {
    usage();
    exit (1);
  }
#define TEST_PORT
#ifdef TEST_PORT
  if (uc_type == 255) {
    fflush(stdin);
    for (i = 0; i < 256; i++) {
      output_data(i);
      rc = read_fake_data();
      printf ("out_data = %02X, in_data = %02X\n", i, rc);
      reply[0] = 'Y';
      printf ("த (Y)? ");
      gets(reply);
      if feof(stdin)
	break;
      if (toupper(reply[0]) != 'Y')
	break;
    }
    exit(1);
  } else
#endif
  if (uc_type == 0) {
    testp = lf2NAND;
    ucname = "74xx00";
  } else if (uc_type == 8) {
    testp = lf2AND;
    ucname = "74xx08";
  } else if (uc_type == 32) {
    testp = lf2OR;
    ucname = "74xx32";
  } else if (uc_type == 86) {
    testp = lf2XOR;
    ucname = "74xx86";
  } else {
    usage();
    exit(1);
  }
  error = 0;
  while (passes--) {
    if (passes > 1)
      printf ("%8ld\r", passes);
    for (i = 0; i < 256; i++) {
      output_data(i);
      rc = read_fake_data();
      ByteToBits(i, inputs);
      ByteToBits(rc, outputs);
      for ( j = 0; j < 4; j++ ) {
	test = (*testp) (inputs[j*2], inputs[j*2+1]);
	if ( test != outputs[j]) {
	  error = 1;
	  printf ("奬 \"%s\" ࠢ\n", ucname);
	  printf ("ᥪ 室 室 \n");
	  printf ("  %d:    %d %d   %d      %d\n", j+1,
		     inputs[j*2], inputs[j*2+1],
		     outputs[j], test);
	  reply[0] = 0;
	  printf ("த(y/n) ? ");
	  gets(reply);
	  if (toupper(reply[0]) != 'Y' || feof(stdin))
	    break;
	}
      }
      if (error && toupper(reply[0]) != 'Y')
	break;
    }
  }
  if (! error)
    printf ("奬 \"%s\" ࠢ\n", ucname);
}
